.586p
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include				\masm32\include\windows.inc
include				\masm32\include\user32.inc
include				\masm32\include\kernel32.inc
include				\masm32\include\shell32.inc
include				\masm32\include\advapi32.inc
include				\masm32\include\gdi32.inc
include				\masm32\include\comctl32.inc
include				\masm32\include\comdlg32.inc
include				\masm32\include\masm32.inc
include				\masm32\macros\macros.asm

includelib			\masm32\lib\user32.lib
includelib			\masm32\lib\kernel32.lib
includelib			\masm32\lib\shell32.lib
includelib			\masm32\lib\advapi32.lib
includelib			\masm32\lib\gdi32.lib
includelib			\masm32\lib\comctl32.lib
includelib			\masm32\lib\comdlg32.lib
includelib			\masm32\lib\masm32.lib

;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GetDiskSN			PROTO :HWND

;******************************************************************************
;* DATA & CONSTANTS                                                           *
;******************************************************************************
.const
IDD_MAIN			equ 	1
BTN_GET				equ 	101
IDC_HDDSN			equ 	102

.data?
GetDiskSerial_dll		dd	?
szSN				db	40h dup(?)

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
	invoke InitCommonControls
	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        
        invoke ExitProcess,0

DialogProc proc uses ebx esi edi hwnd:dword,message:dword,wparam:dword,lparam:dword
	
	mov eax,message
		
	.if eax==WM_COMMAND

		mov eax,wparam

		.if ax==BTN_GET
			shr eax,16
			.if ax==BN_CLICKED
				invoke GetDiskSN,hwnd
			.endif
		.endif
		
	.elseif eax==WM_CLOSE
	
		invoke EndDialog,hwnd,0
		
	.endif
	
	xor eax,eax
	ret 	                         
DialogProc endp


GetDiskSN proc hwnd:HWND

	invoke RtlZeroMemory,addr szSN, sizeof szSN
	
	invoke LoadLibrary,chr$("GetDiskSerial.dll")
	or eax,eax
	jnz _loaded
		invoke SetDlgItemText,hwnd,IDC_HDDSN,chr$("Could not load DLL")
		ret
	_loaded:
	
	mov GetDiskSerial_dll,eax
	
	invoke GetProcAddress,eax,chr$("GetSerialNumber")
	
	push offset szSN
	push 0
	call eax
	
	invoke SetDlgItemText,hwnd,IDC_HDDSN,eax
	
	invoke FreeLibrary,GetDiskSerial_dll

	xor eax,eax
	ret
GetDiskSN endp

end main

Coded by N1ghtm4r3